<?php
/*******************************************************************************
    Wordpress IDX and Contact Manager Plugin
    Copyright (C) 2010 pyHub Limited/Agent Storm

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*******************************************************************************/
?>

    <div class="agentstorm-crumb">
        <?php if (empty($state) && empty($city)): ?>
            Showing <strong><?php echo ($offset + 1); ?></strong> to <strong><?php echo ($properties->Count + $offset); ?></strong> of <strong><?php echo number_format($properties->TotalCount); ?></strong> properties that matched your search criteria.
        <?php else: ?>
            Properties &raquo; <a href="<?php echo bloginfo('url'); ?>/<?php echo get_option('as_idx_urlprefix'); ?>/<?php echo $state; ?>"><?php echo ucwords($state); ?></a> <?php if (!empty($city)): ?>&raquo; <a href="/property/<?php echo $state; ?>/<?php echo urlencode($city); ?>/"><?php echo ucwords($city); ?></a><?php endif; ?>
        <?php endif; ?>
    </div>

<div class="agentstorm-results">
    
    <?php foreach ($results as $result): ?>
    
        <div class="agentstorm-result">
            <div class="agentstorm-result-image">
                <img src="<?php echo $result->Photos[0]->Url; ?>" width="100" />
            </div>
            <div class="agentstorm-result-description">
                <div class="agentstorm-result-address"><?php echo $result->FullAddress; ?></div>
                <div class="agentstorm-result-subaddress"><a href="<?php echo bloginfo('url'); ?>/<?php echo get_option('as_idx_urlprefix'); ?>/<?php echo strtolower($result->State); ?>/<?php echo urlencode(strtolower($result->City)); ?>/"><?php echo ucwords(strtolower($result->City)); ?></a>, <a href="<?php echo bloginfo('url'); ?>/<?php echo get_option('as_idx_urlprefix'); ?>/<?php echo strtolower($result->State); ?>/"><?php echo ucwords(strtolower($result->State)); ?></a>. <?php echo $result->Zip; ?></div>
                <div class="agentstorm-result-list">
                    <div class="agentstorm-result-listitem"><label>Bedrooms:</label> <?php echo ($result->Bedrooms) ? $result->Bedrooms : '<span class="agentstorm-empty">&mdash;</span>'; ?></div>
                    <div class="agentstorm-result-listitem"><label>Bathrooms:</label> <?php echo $result->FullBathrooms + ($result->HalfBathrooms / 2); ?></div>
                    <div class="agentstorm-result-listitem"><label>Total Rooms:</label> <?php echo ($result->Rooms) ? $result->Rooms : '<span class="agentstorm-empty">&mdash;</span>'; ?></div>
                    <div class="agentstorm-result-listitem"><label>Total Garage Spaces:</label> <?php echo ($result->Garage) ? $result->Garage : '<span class="agentstorm-empty">&mdash;</span>'; ?></div>
                    <div class="agentstorm-result-listitem"><label>Year Built:</label> <?php echo ($result->YearBuilt) ? $result->YearBuilt : '<span class="agentstorm-empty">&mdash;</span>'; ?></div>
                </div>
            </div>
            <div class="agentstorm-result-price">$<?php echo number_format($result->ListPrice); ?></div>
            <div class="agentstorm-result-moreinfo"><a href="<?php echo bloginfo('url'); ?>/<?php echo get_option('as_idx_urlprefix'); ?>/<?php echo strtolower($result->State); ?>/<?php echo urlencode(strtolower($result->City)); ?>/<?php echo agentstorm_slugify($result->Id . ' ' . $result->StreetNumber . ' ' . $result->StreetPrefix . ' ' . $result->StreetName . ' ' . $result->StreetSuffix . ' ' . $result->SubDivision . ' ' . $result->City); ?>.html">More Information</a></div>
        </div>
    
    <?php endforeach; ?>
    
    <?php 
    //print_r($properties);
    	$paginator = new AgentStormPagination(array(
    		'total_rows' => $properties->TotalCount,
    		'cur_page' => $offset,
    		'per_page' => $limit,
    		'base_url' => (!empty($state)) ? str_replace('?offset=' . $offset, '', $_SERVER['REQUEST_URI']) . '?offset=' : str_replace('&offset=' . $offset, '', $_SERVER['REQUEST_URI']) . '&offset=',
    		'num_links' => 4,
			'full_tag_open' => '<div class="agentstorm-pager">',
			'full_tag_close' => '</div>',
			'first_link' => 'First',
			'first_tag_open' => '<div class="agentstorm-pager-first">',
			'first_tag_close' => '</div>',
			'last_link' => 'Last',
			'last_tag_open' => '<div class="agentstorm-pager-last">',
			'last_tag_close' => '</div>',
			'next_link' => '&gt;',
			'next_tag_open' => '<div class="agentstorm-pager-next">',
			'next_tag_close' => '</div>',
			'prev_link' => '&lt;',
			'prev_tag_open' => '<div class="agentstorm-pager-prev">',
			'prev_tag_close' => '</div>',
			'cur_tag_open' => '<div class="agentstorm-pager-curr">',
			'cur_tag_close' => '</div>',
			'num_tag_open' => '<div class="agentstorm-pager-numb">',
			'num_tag_close' => '</div>'
    	));
    	
    	echo $paginator->create_links();
    ?>
  
</div>